config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: { sessions: 'users/sessions' }
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  resource :categories
  resource :ingredients

  root to: "categories#index"
end

app/models/category.rb
class Category < ApplicationRecord
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :find_category, only: %i[show edit update destroy]
  def index
    @categories = Category.all
  end

  def new
    @category = Category.new
  end

  def create
    @category = Category.new category_params
    if @category.save
      redirect_to categories_path
    else
      flash[:error]=@book.error.full_messages.join(", ")
      render :new
    end
  end

  def edit
  end

  def update
    if @category.update category_params 
      redirect_to categories_path
    else
      render :edit
    end
  end
  def show
  end

  def destroy
    if @category.destroy 
      redirect_to categories_path
    else
      render :show
    end
  end

  private

  def category_params
    params.require(:category).permit(:name)
  end

  def permitted_params
    params.permit(:id)
  end

  def find_category
    @category=Category.find permitted_params["id"]
  end
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/views/categories/_form.html.erb
<%= form_for(@category) do |f| %>

  <div class="form-group">
    <%= f.label :Name %>
    <%= f.text_field :name, value: @category.name %>
  </div>

  <div class="form-group">
    <%= link_to "Cancel", categories_path %>
    <%= f.submit action.to_s.upcase %>
  </div>
<% end %>

app/views/categories/edit.html.erb
<h3>Update Category</h3>
<%= render 'form', action: 'update' %>

app/views/categories/index.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <a class="navbar-brand" href="#">Navbar</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active">
        <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="#">Link</a>
      </li>
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          Dropdown
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <a class="dropdown-item" href="#">Action</a>
          <a class="dropdown-item" href="#">Another action</a>
          <div class="dropdown-divider"></div>
          <a class="dropdown-item" href="#">Something else here</a>
        </div>
      </li>
      <li class="nav-item">
        <a class="nav-link disabled" href="#" tabindex="-1" aria-disabled="true">Disabled</a>
      </li>
    </ul>

    <form class="form-inline my-2 my-lg-0">
      <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
      <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
    </form>

    <ul class="navbar-nav ml-auto">
      <li class="nav-item">
        <%= link_to "Log out", destroy_user_session_path, method: "delete" %>

      </li>
    </ul>
  </div>
</nav>

<div class="container-fluid">
  <div class="row my-4">
    <div class="col">
      <%= link_to "Ingredients", ingredients_path, class: 'btn btn-primary' %>
      <h3 class="text-capitalize">
        Category
        <div class="btn-group float-right">
          <%= link_to "Add Category", new_categories_path, class: 'btn btn-primary' %>
        </div>
      </h3>
    </div>
  </div>

  <div class="row">
    <div class="col">
      <table class="table table-striped table-hover">
        <tr>
          <th>Name</th>
        </tr>
        <% @categories.each do |category| %>
        <tr>
          <td><%= category.name %></td>
          <td>
            <%= link_to "Edit", edit_categories_path(category.id) %>
            <%= link_to "Show", categories_path(category.id) %>
            <%= link_to "Delete", categories_path(category.id), method: :delete, data: {confirm: "Are you sure?"} %>
          </td>
        </tr>
        <% end %>
      </table>
    </div>
  </div>
</div>

app/views/categories/new.html.erb
<h3>Add Category</h3>
<%= render 'form', action: 'create' %>

app/views/categories/show.html.erb
<div class="container-fluid">

  <div class="row my-4">
    <div class="col">
      <h3>
        <%= @category.name %>
      </h3>
      <div class="col pl-0">
        <small>
          <%= link_to "All Publications", categories_path %>
        </small>
        <div class="btn-group float-right">
          <%= link_to "Edit", edit_category_path(@category.id), class:'btn btn-warning' %>
          <%= link_to "Delete", category_path(@category.id), method: :delete, data: {confirm: "Are your sure?"}, class: 'btn btn-danger' %>
        </div>
      </div>
    </div>
  </div>
</div>